unit YPFKernel;

interface
uses
  Classes, SysUtils, ypf_select;

type
  TYPFEngine = class(TObject)
  private
    Picture: String;
  protected
    { Protected }
    Story: String;    { ȡ꡼ȥ }
    ArgWord: String;  { ѡΥѡĤ }
    Telling: String;  { ɽȥ }
    SoundRequest: String;  { դMIDIե̾ }
    ItemName: String; { 쥯ȥƥȤɲä̾ }
    ItemIndex: Integer; { 쥯ȥƥΥǥå }
    MailBoxSw: Boolean;
  public
    constructor Create;
  published
    function  NextParts(var DataString: String): String;
    function  TagArgc(tag, sep: String): Integer;
    function  TagParts(var tag: String; sep: String): String;
    procedure TagSkip(var tag: String; jump: String);
    function  TagAreaGet(var tag: String; jump: String): String;
    procedure TagAreaSkip(var tag: String; jump: String);
    procedure Execute(prog: String);
    procedure SelectExecute(prog, param: String);
    procedure AddTelling(parts: String);
    procedure SetParameter(name: String; value: Integer);
    function  GetParameter(name: String): Integer;
    procedure DispTelling;
    procedure DoMesDisp; Virtual;
    procedure MIDIPlay(name: String);
    procedure DoSoundPlay;
    procedure SelItemClear;
    procedure SyncItemClear;
    procedure SelItemAdd(index: Integer; name: String);
    procedure SyncItemAdd;
    procedure SelDoDisp;
    procedure SyncSelectDisp;
    procedure ReadFile(Filename: String);
    procedure ReadString(DataString: String); Virtual;
    procedure TagExecute(var prog: String; tag: String); Virtual;
    procedure MailBoxDisp(sw: Boolean); Virtual;
    procedure SyncMailDisp; Virtual;
    procedure PictureScreen(data: String);
    procedure PicScr;
  end;

implementation

uses ypf_main;

{$UNDEF SJIS}

{ --- ե뤫ɤߤǼ¹ }
procedure TYPFEngine.ReadFile(Filename: String);
var Input: TextFile;
var GetLine: String;
begin
  AssignFile(Input, Filename);
  reset(Input);
  Story := '';
  while not EOF(Input) do begin
    ReadLn(Input, GetLine);
    GetLine := Trim(GetLine);
    Story := Story + GetLine;
  end;
  CloseFile(Input);
  ReadString(Story);
end;

{ --- 󤹤Ȥ餯 }
constructor TYPFEngine.Create;
begin
  inherited Create;
end;

{ --- ȥ󥰥¹ }
procedure TYPFEngine.ReadString(DataString: String);
var bit, tag, body: String;
var c, i: Integer;
begin
  { ʸϥǡν }
  Telling := '';
  { ǡפ̤ʬ }
  while length(DataString) > 0 do
  begin
    bit := NextParts(DataString);
    if bit[1] = '<' then
    begin
      c := TagArgc(bit, ' ');
      tag := TagParts(bit, ' ');
      if tag = 'ml_event' then
      begin
        { event ֥ȤȤϤ }
        body := TagAreaGet(DataString, 'ml_event');
        Execute(body);
        DispTelling;
      end;
      if tag = 'ml_receive' then
      begin
        { receive ֥ȤȤϤ }
      end;
      if tag = 'ml_send' then
      begin
        { send ֥ȤȤϤ }
      end;
    end
  end;
end;

{ --- ꥿ϰϤФ }
function TYPFEngine.TagAreaGet(var tag: String; jump: String): String;
var retbuf, endtag, tmp, nesttag: String;
var nest: Integer;
begin
  nest := 0;
  tmp := jump;
  endtag := TagParts(tmp, ' ');
  endtag := '/' + endtag;
  retbuf := '';
  while length(tag) > 0 do
  begin
    tmp := NextParts(tag);
    if (tmp[1] = '<') and (pos(endtag, tmp) > 0) then
      if nest = 0 then break
      else
        nest := nest -  1
    else
    if pos(jump, tmp) > 0 then
      nest := nest + 1;
    retbuf := retbuf + tmp;
  end;
  TagAreaGet := retbuf;
end;

{ --- ꥿ϰϥå }
procedure TYPFEngine.TagAreaSkip(var tag: String; jump: String);
var tmp: String;
begin
  tmp := TagAreaGet(tag, jump);
end;

{ --- ꥿ޤǥå }
procedure TYPFEngine.TagSkip(var tag: String; jump: String);
var bit: String;
begin
  repeat
    bit := NextParts(tag);
    bit := TagParts(bit, ' ');
  until bit = jump;
end;

{ ---  argmrnt 夲 }
function  TYPFEngine.TagArgc(tag, sep: String): Integer;
var  i, l, c: Integer;
var  post: String;
begin
  l := Length(tag);
  post := sep;
  if l > 0 then c := 1
  else begin
    TagArgc := 0;
    exit;
  end;
  for i := 1 to l do
  begin
    if tag[i] = sep then
    begin
      if post <> sep then
        c := c + 1;
    end;
    post := tag[i];
  end;
  TagArgc := c;
end;

{ ---  1arg Ф }
function  TYPFEngine.TagParts(var tag: String; sep: String): String;
var  i, l: Integer;
var  ret, post: String;
var  chr: Byte;
begin
  l := Length(tag);
  if tag[l] = '>' then
  begin
    Delete(tag, l, 1);
    l := l - 1;
  end;
  if tag[1] = '<' then
  begin
    Delete(tag, 1, 1);
    l := l - 1;
  end;
  post := sep;
  ret := '';
  while length(tag) > 0 do
  begin
    if tag[1] = sep then
      if post = sep then
      begin
        Delete(tag, 1, 1);
        continue;
      end
      else break;
    chr := byte(tag[1]);
    post := tag[1];
    if ((chr > $80) and (chr < $a0)) or
    ((chr > $df) and (chr < $f0)) then
    begin
      ret := ret + tag[1] + tag[2];
      Delete(tag, 1, 2);
    end
    else
    begin
      ret := ret + tag[1];
      Delete(tag, 1, 1);
    end;
  end;
  Delete(tag, 1, 1);
  TagParts := ret;
end;

{ --- ǡ򥿥Ȥ¾ʬ1Ĥ֤ }
function  TYPFEngine.NextParts(var DataString: String): String;
var retbuf: String;
var chr: Byte;
begin
  DataString := Trim(DataString);
  chr := byte(DataString[1]);
  if chr = Byte('<') then
  begin
    { Ф }
    retbuf := DataString[1];
    Delete(DataString, 1, 1);
    while length(DataString) > 0 do
    begin
      chr := byte(DataString[1]);
{$IFDEF SJIS}
      if ((chr > $80) and (chr < $a0)) or
          ((chr > $df) and (chr < $f0)) then
{$ELSE}
      if (chr > $A0) and (chr <= $fe) then
{$ENDIF}
      begin
        retbuf := retbuf + DataString[1] + DataString[2];
        Delete(DataString, 1, 2);
      end
      else begin
        retbuf := retbuf + AnsiLowerCase(DataString[1]);
        Delete(DataString, 1, 1);
        if chr = Byte('>') then break;
      end;
    end;
  end
  else begin
    { ʳξ󤭤Ф }
    Retbuf := '';
    while length(DataString) > 0 do
    begin
      chr := byte(DataString[1]);
{$IFDEF SJIS}
      if ((chr > $80) and (chr < $a0)) or
          ((chr > $df) and (chr < $f0)) then
{$ELSE}
      if (chr > $a0) and (chr <= $fe) then
{$ENDIF}
      begin
        retbuf := retbuf + DataString[1] + DataString[2];
        Delete(DataString, 1, 2);
      end
      else begin
        if chr = Byte('<') then break;
        retbuf := retbuf + AnsiLowerCase(DataString[1]);
        Delete(DataString, 1, 1);
      end;
    end;
  end;
  retbuf := Trim(retbuf);
  NextParts := retbuf;
end;


{ --- եβϼ¹ }
procedure TYPFEngine.Execute(prog: String);
var bit, arg: String;
begin
  { ǡĹʬ¹ }
  while length(prog) > 0 do
  begin
    bit := NextParts(prog);
    if bit[1] <> '<' then AddTelling(bit)
    else begin
      { --- βϡ¹ }
      TagExecute(prog, bit);
    end;
  end;
end;

procedure TYPFEngine.TagExecute(var prog: String; tag: String);
var arg, subprog, param: String;
var num, r: Integer;
begin
  arg := TagParts(tag, ' ');
  {ʸ}
{$IFDEF SJIS}
  if arg = 'br'    then AddTelling(Char($f0));
  if arg = 'p'     then AddTelling(Char($f1));
  if arg = 'w'     then AddTelling(Char($f2));
  if arg = 'pause' then AddTelling(Char($f3));
  if arg = 'b'     then AddTelling(Char($f4));
  if arg = '/b'    then AddTelling(Char($f5));
  if arg = 'col'   then AddTelling(Char($f6));
  if arg = '/col'  then AddTelling(Char($f7));
{$ELSE}
  if arg = 'br'    then AddTelling(Char($FF)+Char($f0));
  if arg = 'p'     then AddTelling(Char($FF)+Char($f1));
  if arg = 'w'     then AddTelling(Char($FF)+Char($f2));
  if arg = 'pause' then AddTelling(Char($FF)+Char($f3));
  if arg = 'b'     then AddTelling(Char($FF)+Char($f4));
  if arg = '/b'    then AddTelling(Char($FF)+Char($f5));
  if arg = 'col'   then AddTelling(Char($FF)+Char($f6));
  if arg = '/col'  then AddTelling(Char($FF)+Char($f7));
{$ENDIF}
  {٥ȥեå}
  if arg = 'picture' then
  begin
    DispTelling;
    if TagArgc(tag, ' ') > 0 then
    begin
      param := TagParts(tag, ' ');
      PictureScreen(param);
    end;
  end;
  { ɥꥯ }
  if arg = 'bgm' then
  begin
    if TagArgc(tag, ' ') > 0 then
    begin
      param := TagParts(tag, ' ');
      MIDIPlay(param);
    end;
  end;
  {ץ쥤䡼}
  if arg = 'select' then
  begin
    if TagArgc(tag, ' ') > 0 then
    begin
      param := TagParts(tag, ' ');
      subprog := TagAreaGet(prog, 'select');
      SelectExecute(subprog, param);
    end;
  end;
  {ƾ}
  if arg = 'you' then AddTelling(PenpalMain.CallYou);
  if arg = 'me' then AddTelling(PenpalMain.CallMe);
  if arg = 'setyou' then
  begin
    param := TagAreaGet(prog, 'setyou');
    PenpalMain.CallYou := param;
  end;
  if arg = 'setme' then
  begin
    param := TagAreaGet(prog, 'setme');
    PenpalMain.CallMe := param;
  end;
  {ե饰}
  if arg = 'flagset' then
  begin
    if TagArgc(tag, ' ') > 0 then
    begin
      param := TagParts(tag, ' ');
      SetParameter(param, 1);
    end;
  end;
  if arg = 'flagreset' then
  begin
    if TagArgc(tag, ' ') > 0 then
    begin
      param := TagParts(tag, ' ');
      SetParameter(param, 0);
    end;
  end;
  if arg = 'flagif' then
  begin
    if TagArgc(tag, ' ') > 0 then
    begin
      param := TagParts(tag, ' ');
      if GetParameter(param) = 1 then
      begin
        subprog := TagAreaGet(prog, 'flagif');
        Execute(subprog);
      end
      else TagAreaSkip(prog, 'flagif');
    end;
  end;
  if arg = 'flagunless' then
  begin
    if TagArgc(tag, ' ') > 0 then
    begin
      param := TagParts(tag, ' ');
      if GetParameter(param) = 0 then
      begin
        subprog := TagAreaGet(prog, 'flagunless');
        Execute(subprog);
      end
      else TagAreaSkip(prog, 'flagunless');
    end;
  end;
  {ѥ᡼}
  if arg = 'parmset' then
  begin
    if TagArgc(tag, ' ') = 3 then
    begin
      param := TagParts(tag, ' ');
      num   := StrToInt(TagParts(tag, ' '));
      r     := StrToInt(TagParts(tag, ' '));
      num := num + Random(r);
      SetParameter(param, num);
    end;
  end;
  if arg = 'parmadd' then
  begin
    if TagArgc(tag, ' ') = 3 then
    begin
      param := TagParts(tag, ' ');
      num   := StrToInt(TagParts(tag, ' '));
      r     := StrToInt(TagParts(tag, ' '));
      num := GetParameter(param) + num;
      num := num + Random(r);
      SetParameter(param, num);
    end;
  end;
  if arg = 'parmsub' then
  begin
    if TagArgc(tag, ' ') = 3 then
    begin
      param := TagParts(tag, ' ');
      num   := StrToInt(TagParts(tag, ' '));
      r     := StrToInt(TagParts(tag, ' '));
      num := GetParameter(param) - num;
      num := num + Random(r);
      SetParameter(param, num);
    end;
  end;
  if arg = 'parmeq' then
  begin
    if TagArgc(tag, ' ') = 2 then
    begin
      param := TagParts(tag, ' ');
      num   := StrToInt(TagParts(tag, ' '));
      r     := GetParameter(param);
      if r = num then
      begin
        subprog := TagAreaGet(prog, 'parmeq');
        Execute(subprog);
      end
      else TagAreaSkip(prog, 'parmeq');
    end;
  end;
  if arg = 'parmge' then
  begin
    if TagArgc(tag, ' ') = 2 then
    begin
      param := TagParts(tag, ' ');
      num   := StrToInt(TagParts(tag, ' '));
      r     := GetParameter(param);
      if r >= num then
      begin
        subprog := TagAreaGet(prog, 'parmge');
        Execute(subprog);
      end
      else TagAreaSkip(prog, 'parmge');
    end;
  end;
  if arg = 'parmlt' then
  begin
    if TagArgc(tag, ' ') = 2 then
    begin
      param := TagParts(tag, ' ');
      num   := StrToInt(TagParts(tag, ' '));
      r     := GetParameter(param);
      if r < num then
      begin
        subprog := TagAreaGet(prog, 'parmlt');
        Execute(subprog);
      end
      else TagAreaSkip(prog, 'parmlt');
    end;
  end;
end;


{ --- ˥塼ɽƥץ쥤䡼ϤԤ }
procedure TYPFEngine.SelectExecute(prog, param: String);
var bit, arg, item: String;
var index, num: Integer;
begin
  DispTelling;
  SelItemClear;
  {Selecter.ItemClear;}
  num := 0;
  while length(prog) > 0 do
  begin
    { -- ƥϿ }
    bit := NextParts(prog);
    if bit[1] = '<'  then
    begin
      arg := TagParts(bit, ' ');
      if arg = 'item' then
      begin
        if TagArgc(bit, ' ') > 0 then
        begin
          arg := TagParts(bit, ' ');
          index := StrToInt(arg);
          item := TagAreaGet(prog, 'item');
          SelItemAdd(index, item);
          {Selecter.ItemAdd(item, index);}
          num := num + 1;
        end;
      end;
    end;
  end;
  if num > 0 then begin
    { -- Ԥ }
    PenpalMain.SelectFlag := False;
    SelDoDisp;
    {Selecter.ShowModal;}
    while PenpalMain.SelectFlag = False do Sleep(100);
    Sleep(300);
    index := PenpalMain.UserSelect;
    SetParameter(param, index);
  end;
end;


{ --- ɽåʸϤΰդä }
procedure TYPFEngine.AddTelling(parts: String);
begin
  Telling := Telling + parts;
end;

{ --- ѥ᡼ʥե饰ˤ򥻥åȤ }
procedure TYPFEngine.SetParameter(name: String; value: Integer);
begin
  PenpalMain.SetParameter(name, value);
end;

{ --- ѥ᡼ʥե饰ˤ򥲥åȤ }
function  TYPFEngine.GetParameter(name: String): Integer;
begin
  GetParameter := PenpalMain.GetParameter(name);
end;

{ --- ʸϤɽ륳 }
procedure TYPFEngine.DispTelling;
begin
  if length(Telling) > 0 then
  begin
    PenpalMain.StoryExec.Synchronizer(DoMesDisp);
    while PenpalMain.eventMessageFlag = True do Sleep(100);
    Telling := '';
  end;
end;

{ --- ºݤʸϤɽ᥽å }
procedure TYPFEngine.DoMesDisp;
begin
  {PenpalMain.MessageDisplay(Telling);  --- ƥѥǤ }
end;

{ --- ڤդ륳 }
procedure TYPFEngine.MIDIPlay(name: String);
begin
  SoundRequest := name;
  PenpalMain.StoryExec.Synchronizer(DoSoundPlay);
end;

{ --- ºݤ˲ڤդ᥽å }
procedure TYPFEngine.DoSoundPlay;
begin
  PenpalMain.MIDIPlayerRequest(SoundRequest);
end;


{ --- 쥯Ƥơ }
procedure TYPFEngine.SelItemClear;
begin
  PenpalMain.StoryExec.Synchronizer(SyncItemClear);
end;
{ --- ºݤ˥쥯ν򤹤᥽å }
procedure TYPFEngine.SyncItemClear;
begin
  Selecter.ItemClear;
end;
{ --- 쥯ȥƥɲäƤƥ }
procedure TYPFEngine.SelItemAdd(index: Integer; name: String);
begin
  ItemName := name;
  ItemIndex := index;
  PenpalMain.StoryExec.Synchronizer(SyncItemAdd);
end;
{ --- ºݤ˥ƥɲä᥽å }
procedure TYPFEngine.SyncItemAdd;
begin
  Selecter.ItemAdd(ItemName, ItemIndex);
end;
{ --- 쥯ɽơ }
procedure TYPFEngine.SelDoDisp;
begin
  PenpalMain.StoryExec.Synchronizer(SyncSelectDisp);
end;
{ --- ºݤ˥쥯ɽ᥽å }
procedure TYPFEngine.SyncSelectDisp;
begin
  PenpalMain.DoSelect;
end;

{ --- ᡼ܥåɽȥ }
procedure TYPFEngine.MailBoxDisp(sw: Boolean);
begin
  MailBoxSw := sw;
  PenpalMain.StoryExec.Synchronizer(SyncMailDisp);
end;
{ --- ºݤ˥᡼ܥåɽ᥽å }
procedure TYPFEngine.SyncMailDisp;
begin
  PenpalMain.MailManeger.Visible := MailBoxSw;
end;

{ --- եḁ̊ꥯ }
procedure TYPFEngine.PictureScreen(data: String);
begin
  Picture := data;
  PenpalMain.StoryExec.Synchronizer(PicScr);
end;

{ --- ºݤ˥եå̤ɽ᥽å }
procedure TYPFEngine.PicScr;
begin
  PenpalMain.NextPicture(Picture);
end;


end.
