unit YPFKernel2;

interface
uses
  QGraphics, QDialogs, ypf_select, YPFKernel, QControls,
  resdialog, snddialog, sndaccept, SysUtils, Classes;

type
  TYPFGeneral = class(TYPFEngine)
  procedure ReadString(DataString: String); override;
  public
    NextFile: String;
  end;

type
  TYPFEvent = class(TYPFEngine)
    procedure ReadString(DataString: String); override;
    procedure TagExecute(var prog: String; tag: String); override;
    procedure DoMesDisp; override;
    procedure MessageScreen(sw: Boolean);
    procedure MesScrSwitch;
    procedure AlbumSet(picname, index: String);
    procedure SyncAlbum;
  private
    MesScr: Boolean;
    Picture: String;
    PictureIndex: String;
  end;

const parameter_max = 512;

type
  TYPFSend = class(TYPFEngine)
    procedure ReadString(DataString: String); override;
    procedure TagExecute(var prog: String; tag: String); override;
    procedure DoMesDisp; override;
    procedure Header(name: String);
    procedure SyncHeader;
    procedure Footer(name: String);
    procedure SyncFooter;
    procedure LogSet;
    procedure SyncLog;
    procedure PostDialog;
    procedure SyncDialog;
    procedure DoPostDialog;
    procedure SyncDoDialog;
    procedure SyncMailDisp;
    procedure WriteButton;
    procedure SyncWriteButton;
    procedure SendButton;
    procedure SyncSendButton;
    procedure WriteShutter;
    procedure SyncWriteShutter;
  private
    Log: String;
    LogIndex: String;
    HeaderFile: String;
    FooterFile: String;
  public
  end;

type
  TYPFReceive = class(TYPFEngine)
    procedure ReadString(DataString: String); override;
    procedure TagExecute(var prog: String; tag: String); override;
    procedure DoMesDisp; override;
    procedure Header(name: String);
    procedure SyncHeader;
    procedure Footer(name: String);
    procedure SyncFooter;
    procedure LogSet;
    procedure SyncLog;
    procedure PostDialog;
    procedure SyncDialog;
    procedure SyncMailDisp; override;
    procedure DoneButton;
    procedure SyncDoneButton;
  private
    Log: String;
    LogIndex: String;
    HeaderFile: String;
    FooterFile: String;
  public
  end;


implementation

uses
  ypf_main, meswin;

{-----------------------------------------------------}
{======= ȡ꡼󥸥ᥤ }

procedure TYPFGeneral.ReadString(DataString: String);
var bit, tag, body: String;
var c, i: Integer;
var
  YPFEvent: TYPFEvent;
  YPFSend: TYPFSend;
  YPFReceive: TYPFReceive;
begin
  NextFile := 'title.mle';
  { ʸϥǡν }
  Telling := '';
  { ǡפ̤ʬ }
  while length(DataString) > 0 do
  begin
    bit := NextParts(DataString);
    if bit[1] = '<' then
    begin
      c := TagArgc(bit, ' ');
      tag := TagParts(bit, ' ');
      if tag = 'ml_event' then
      begin
        { event ֥ȤȤϤ }
        body := TagAreaGet(DataString, 'ml_event');
        YPFEvent := TYPFEvent.Create;
        YPFEvent.ReadString(body);
        YPFEvent.Free;
      end;
      if tag = 'ml_receive' then
      begin
        { receive ֥ȤȤϤ }
        body := TagAreaGet(DataString, 'ml_receive');
        YPFReceive := TYPFReceive.Create;
        YPFReceive.ReadString(body);
        YPFReceive.Free;
      end;
      if tag = 'ml_send' then
      begin
        { send ֥ȤȤϤ }
        body := TagAreaGet(DataString, 'ml_send');
        YPFSend := TYPFSend.Create;
        YPFSend.ReadString(body);
        YPFSend.Free;
      end;
      if tag = 'fileread' then
      begin
        { Υեɤ߹߼¹Ԥ }
        if c > 1 then
        begin
          NextFile := TagParts(bit, ' ');
          break;
        end;
      end;
    end
  end;
end;


{-----------------------------------------------------}
{======= Event ¹ʬ }

procedure TYPFEvent.ReadString(DataString: String);
begin
  { ʸϥǡν }
  Telling := '';
  MailBoxDisp(False);
  Execute(DataString);
  DispTelling;
end;

procedure TYPFEvent.TagExecute(var prog: String; tag: String);
var arg, subprog, param: String;
var num, r: Integer;
var StoryEngine: TYPFGeneral;
begin
  inherited;
  arg := TagParts(tag, ' ');
  {󥯥롼ɥեμ¹}
  if arg = 'include'    then
  begin
    DispTelling;
    if TagArgc(tag, ' ') > 0 then
    begin
      arg := TagParts(tag, ' ');
      StoryEngine := TYPFGeneral.Create;
      StoryEngine.ReadFile(arg);
      StoryEngine.Free;
    end;
  end;
  {ץ쥤䡼ΥԤ}
  if arg = 'clickwait'    then
  begin
    DispTelling;
    PenpalMain.ClickWait := False;
    while PenpalMain.ClickWait = False do Sleep(100);
  end;
  {åɥط}
  if arg = 'meswinon'    then MessageScreen(True);
  if arg = 'meswinoff'   then MessageScreen(False);
  {ХϿ}
  if arg = 'album' then
  begin
    if TagArgc(tag, ' ') = 2 then
    begin
      arg := TagParts(tag, ' ');
      param := TagParts(tag, ' ');
      AlbumSet(arg, param);
    end;
  end;
  {ɤ߹ե}
  if arg = 'fileread' then
  begin
    if TagArgc(tag, ' ') > 0 then
    begin
      arg := TagParts(tag, ' ');
      PenpalMain.StoryExec.StoryEngine.NextFile := arg;
    end;
  end;
end;

{ --- ºݤʸϤɽ᥽å }
procedure TYPFEvent.DoMesDisp;
begin
  PenpalMain.MessageDisplay(Telling);
end;

{ --- å꡼ꥯ }
procedure TYPFEvent.MessageScreen(sw: Boolean);
begin
  MesScr := sw;
  PenpalMain.StoryExec.Synchronizer(MesScrSwitch);
end;

{ --- ºݤ˥å꡼ɽ᥽å }
procedure TYPFEvent.MesScrSwitch;
begin
  PenpalMain.MessageScreen(MesScr)
end;

{ --- ᡼򥢥ХϿ }
procedure TYPFEvent.AlbumSet(picname, index: String);
begin
  Picture := picname;
  PictureIndex := index;
  PenpalMain.StoryExec.Synchronizer(SyncAlbum);
end;

procedure TYPFEvent.SyncAlbum;
begin
  PenpalMain.AddAlbum(Picture, PictureIndex);
end;


{-----------------------------------------------------}
{======= Send ¹ʬ }

procedure TYPFSend.ReadString(DataString: String);
var ParamCopyName: TStringList;
var ParamCopyValue: Array [0..parameter_max] of Integer;
var i: Integer;
begin
  { ʸϥǡν }
  HeaderFile := 'header.bmp';
  FooterFile := 'footer.bmp';
  MailBoxDisp(True);
  PostDialog;
  { ѥ᡼ }
  ParamCopyName := TStringList.Create;
  ParamCopyName.Clear;
  ParamCopyName.AddStrings(PenpalMain.ParameterName);
  for i := 0 to parameter_max do
  begin
    ParamCopyValue[i] := PenpalMain.ParameterValue[i];
  end;
  { 񤳤ܥɽȥåԤ }
  PenpalMain.PickupPen := True;
  WriteButton;
  while PenpalMain.PickupPen = True do Sleep(100);
  repeat
  begin
    { ѥ᡼ }
    PenpalMain.ParameterName.Clear;
    PenpalMain.ParameterName.AddStrings(ParamCopyName);
    for i := 0 to parameter_max do
    begin
      PenpalMain.ParameterValue[i] := ParamCopyValue[i];
    end;
    Telling := '';
    Log := '';
    LogIndex := 'sendmail';
    Header(HeaderFile);
    Execute(DataString);
    DispTelling;
    Footer(FooterFile);
    { ޤܥɽȥåԤ }
    PenpalMain.PickupPen := True;
    SendButton;
    while PenpalMain.PickupPen = True do Sleep(100);
    { ɤ }
    DoPostDialog;
  end
  until PenpalMain.DoSendDialog.ModalResult = mrOK;
  ParamCopyName.Free;
  LogSet;
  WriteShutter;
end;

procedure TYPFSend.TagExecute(var prog: String; tag: String);
var arg, subprog, param: String;
var num, r: Integer;
begin
  inherited;
  arg := TagParts(tag, ' ');
  { -- إåɽ䵽 }
  if arg = 'header' then
  begin
    Telling := '';
    Log := '';
    if TagArgc(tag, ' ') > 0 then
    begin
      param := TagParts(tag, ' ');
      Header(param);
    end;
  end;
  { -- եåΥեå }
  if arg = 'footer' then
  begin
    DispTelling;
    if TagArgc(tag, ' ') > 0 then
    begin
      param := TagParts(tag, ' ');
    end;
  end;
  { -- ȢѤΥȥ륿 }
  if arg = 'title' then
  begin
    LogIndex := TagAreaGet(prog, 'title');
  end;
end;

{ --- ºݤʸϤɽ᥽å }
procedure TYPFSend.DoMesDisp;
begin
  Log := Log + Telling;
  PenpalMain.Writeing.Visible := False;
  PenpalMain.Writeing.MessageRequest(Telling);
  PenpalMain.Writeing.Visible := True;
end;

{ --- إåɽ䵤 }
procedure TYPFSend.Header(name: String);
begin
  HeaderFile := name;
  PenpalMain.StoryExec.Synchronizer(SyncHeader);
end;

procedure TYPFSend.SyncHeader;
var bmp: TBitmap;
begin
  bmp := TBitmap.Create;
  bmp.LoadFromFile(Headerfile);
  PenpalMain.Writeing.MessageClear(bmp);
  bmp.free;
end;

{ --- եå䵤 }
procedure TYPFSend.Footer(name: String);
begin
  FooterFile := name;
  PenpalMain.StoryExec.Synchronizer(SyncFooter);
end;

procedure TYPFSend.SyncFooter;
var bmp: TBitmap;
begin
  bmp := TBitmap.Create;
  bmp.LoadFromFile(FooterFile);
  PenpalMain.Writeing.AddPicture(bmp);
  bmp.free;
end;

{ --- ȢϿ }
procedure TYPFSend.LogSet;
begin
  PenpalMain.StoryExec.Synchronizer(SyncLog);
end;

procedure TYPFSend.SyncLog;
begin
  PenpalMain.AddSendLog(Log, LogIndex, HeaderFile, FooterFile);
end;

{ --- ɽ }
procedure TYPFSend.PostDialog;
begin
  PenpalMain.StoryExec.Synchronizer(SyncDialog);
end;

procedure TYPFSend.SyncDialog;
begin
  PenpalMain.SendDialog := TSendDialog.Create(PenpalMain);
  PenpalMain.SendDialog.ShowModal;
end;

{ --- ǧɽ }
procedure TYPFSend.DoPostDialog;
begin
  PenpalMain.StoryExec.Synchronizer(SyncDoDialog);
end;

procedure TYPFSend.SyncDoDialog;
begin
  PenpalMain.DoSendDialog := TDoSendAccept.Create(PenpalMain);
  PenpalMain.DoSendDialog.ShowModal;
end;

{ --- ºݤ˥᡼ܥåɽ᥽å }
procedure TYPFSend.SyncMailDisp;
begin
  PenpalMain.MailManeger.Visible := MailBoxSw;
  {PenpalMain.MailManeger.ActivePage := PenpalMain.TabWrite;}
end;

{ --- 񤳤ܥ }
procedure TYPFSend.WriteButton;
begin
  PenpalMain.StoryExec.Synchronizer(SyncWriteButton);
end;

procedure TYPFSend.SyncWriteButton;
begin
  PenpalMain.StartWrite.Visible := True;
end;

{ --- ܥ }
procedure TYPFSend.SendButton;
begin
  PenpalMain.StoryExec.Synchronizer(SyncSendButton);
end;

procedure TYPFSend.SyncSendButton;
begin
  PenpalMain.SendWrite.Visible := True;
end;

{ --- ؤ򥷥åǺɤ }
procedure TYPFSend.WriteShutter;
begin
  PenpalMain.StoryExec.Synchronizer(SyncWriteshutter);
end;

procedure TYPFSend.SyncWriteShutter;
var bmp: TBitmap;
var cname : array[0..128] of char;
begin
  bmp := TBitmap.Create;
  bmp.LoadFromFile(StrPCopy(cname, 'shuter01.bmp'));
  penpalMain.Writeing.MessageClear(bmp);
  bmp.Destroy;
end;


{-----------------------------------------------------}
{======= Receive ¹ʬ }

procedure TYPFReceive.ReadString(DataString: String);
begin
  { ʸϥǡν }
  Telling := '';
  Log := '';
  LogIndex := 'mail';
  HeaderFile := 'header.bmp';
  FooterFile := 'footer.bmp';
  PostDialog;
  MailBoxDisp(True);
  Header(HeaderFile);
  Execute(DataString);
  DispTelling;
  LogSet;
end;

procedure TYPFReceive.TagExecute(var prog: String; tag: String);
var arg, subprog, param: String;
var num, r: Integer;
begin
  inherited;
  arg := TagParts(tag, ' ');
  { -- إåɽ䵽 }
  if arg = 'header' then
  begin
    Telling := '';
    Log := '';
    if TagArgc(tag, ' ') > 0 then
    begin
      param := TagParts(tag, ' ');
      Header(param);
    end;
  end;
  { -- եåΥեå }
  if arg = 'footer' then
  begin
    DispTelling;
    if TagArgc(tag, ' ') > 0 then
    begin
      param := TagParts(tag, ' ');
      Footer(param);
    end;
  end;
  { -- ȢѤΥȥ륿 }
  if arg = 'title' then
  begin
    LogIndex := TagAreaGet(prog, 'title');
  end;
  { -- ɤߤޤܥɽȥåԤ }
  if arg = 'readdone' then
  begin
    PenpalMain.PickupPen := True;
    DoneButton;
    while PenpalMain.PickupPen = True do Sleep(100);
  end;
end;

{ --- ºݤʸϤɽ᥽å }
procedure TYPFReceive.DoMesDisp;
begin
  Log := Log + Telling;
  PenpalMain.PostLetter.Visible := False;
  PenpalMain.PostLetter.MessageRequest(Telling);
  PenpalMain.PostLetter.Visible := True;
end;

{ --- إåɽ䵤 }
procedure TYPFReceive.Header(name: String);
begin
  HeaderFile := name;
  PenpalMain.StoryExec.Synchronizer(SyncHeader);
end;

procedure TYPFReceive.SyncHeader;
var bmp: TBitmap;
begin
  bmp := TBitmap.Create;
  bmp.LoadFromFile(Headerfile);
  PenpalMain.PostLetter.MessageClear(bmp);
  bmp.free;
end;

{ --- եå䵤 }
procedure TYPFReceive.Footer(name: String);
begin
  FooterFile := name;
  PenpalMain.StoryExec.Synchronizer(SyncFooter);
end;

procedure TYPFReceive.SyncFooter;
var bmp: TBitmap;
begin
  bmp := TBitmap.Create;
  bmp.LoadFromFile(FooterFile);
  PenpalMain.PostLetter.AddPicture(bmp);
  bmp.free;
end;

{ --- ȢϿ }
procedure TYPFReceive.LogSet;
begin
  PenpalMain.StoryExec.Synchronizer(SyncLog);
end;

procedure TYPFReceive.SyncLog;
begin
  PenpalMain.AddReceiveLog(Log, LogIndex, HeaderFile, FooterFile);
end;

{ --- ɽ }
procedure TYPFReceive.PostDialog;
begin
  PenpalMain.StoryExec.Synchronizer(SyncDialog);
end;

procedure TYPFReceive.SyncDialog;
begin
  PenpalMain.ReceiveDialog := TReceiveDialog.Create(PenpalMain);
  PenpalMain.ReceiveDialog.ShowModal;
end;

{ --- ɤܥ }
procedure TYPFReceive.DoneButton;
begin
  PenpalMain.StoryExec.Synchronizer(SyncDoneButton);
end;

procedure TYPFReceive.SyncDoneButton;
begin
  PenpalMain.ReceiveDone.Visible := True;
end;

{ --- ºݤ˥᡼ܥåɽ᥽å }
procedure TYPFReceive.SyncMailDisp;
begin
  PenpalMain.MailManeger.Visible := MailBoxSw;
  PenpalMain.MailManeger.ActivePage := PenpalMain.TabReceive;
end;

end.
