unit euc2uni;

{ ========================================================= }
{ -- String  EUC ʸȤߤʤ UNICODE WideString  --}
{ -- Ѵ򤹤롼                                   --}
{ ========================================================= }

interface

uses
  SysUtils, Classes, Types;

type
  TE2Uni = class(TObject)
  private
   cache : array [0..255] of Integer;
   cache_tag : Integer;
   function Mapping(euc : Integer): Integer;
   function MappingCache(euc : Integer): Integer;
  protected
  public
    constructor Create;
    function CnvStr(str: String): WideString;
    function CnvStrCache(str: String): WideString;
  published
  end;


   {$INCLUDE 'unicode_table.inc'}

implementation

{ ---- 饹ν }
constructor TE2Uni.Create;
var
   i : Integer;
begin
   inherited Create;
   for i := 0 to 255 do
     cache[i] := 0;
   cache_tag := 0;
end;

{ ---- EUCʸUNICODEʸѴ }
function TE2Uni.CnvStr(str: String): WideString;
var
   unistr : WideString;
   chr	  : Byte;
   euc	  : Integer;
   uni	  : Integer;
begin
   unistr := '';
   while length(str) > 0 do begin
      chr := byte(str[1]);
      if chr < $80 then
      begin
	 { --- ASCII code }
	 euc := Integer(chr);
	 uni := Mapping(euc);
	 Delete(str, 1, 1);
      end
      else
      begin
	 { --- 2byte code }
	 euc := Integer(str[2]) + (Integer(str[1]) * 256);
	 uni := Mapping(euc);
	 Delete(str, 1, 2);
      end;
      { --- UNICODEʸɲ }
      unistr := unistr + WideChar(uni);
   end;
   { -- ̤֤ }
   CnvStr := unistr;
end;

{ ---- EUCʸUNICODEʸѴåб }
function TE2Uni.CnvStrCache(str: String): WideString;
var
   unistr : WideString;
   chr	  : Byte;
   euc	  : Integer;
   uni	  : Integer;
begin
   unistr := '';
   while length(str) > 0 do begin
      chr := byte(str[1]);
      if chr < $80 then
      begin
	 { --- ASCII code }
	 euc := Integer(chr);
	 uni := MappingCache(euc);
	 Delete(str, 1, 1);
      end
      else
      begin
	 { --- 2byte code }
	 euc := Integer(str[2]) + (Integer(str[1]) * 256);
	 uni := MappingCache(euc);
	 Delete(str, 1, 2);
      end;
      { --- UNICODEʸɲ }
      unistr := unistr + WideChar(uni);
   end;
   { -- ̤֤ }
   CnvStrCache := unistr;
end;

{ ----- EUCʸ 1ʸ UNICODE ˥ޥå }
function TE2Uni.Mapping(euc: Integer): Integer;
var
   ret : Integer;
   i   : Integer;
begin
   ret := 0;
   if (euc < $80) then
   begin
      { --- ASCII }
      ret := euc;
   end
   else
   begin
      { --- ܸ̾쥳ɸ }
      for i := 0 to (TBLNUM-1) do
      begin
	if Unitbl[i*2] = euc then
	begin
	   ret := Unitbl[(i*2)+1];
	   break;
	end;
      end;
   end;
   { - ޤ }
   Mapping := ret;
end;

{ ----- EUCʸ 1ʸ UNICODE ˥ޥåסåб }
function TE2Uni.MappingCache(euc: Integer): Integer;
var
   uni : Integer;
   i   : Integer;
begin
   uni := 0;
   { --- å椫饳ɤõ }
   for i := 0 to 127 do
     if cache[i*2] = euc then
     begin
       uni := cache[(i*2)+1];
       break;
     end;
   { --- å˰äʤä̤õ }
   if uni = 0 then
   begin
      uni := Mapping(euc);
      { -- åϿ }
      cache[cache_tag * 2] := euc;
      cache[(cache_tag * 2) + 1] := uni;
      cache_tag := (cache_tag + 1) mod 128;
   end;
   { --- ̤֤ }
   MappingCache := uni;
end;


end.
