unit letterpad;

interface

uses
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QExtCtrls, Types, euc2uni;

type
  TLetterpad = class(TImage)
  private
    FontX, FontY: Integer;
    StrCnv : TE2Uni;
    procedure Kaigyou;
    function KinsokuCheck(kana: String): Boolean;
  protected
    { Protected  }
  public
    DisplayFont: TFont;
    LineColor: TColor;
    constructor Create(AOwner: TComponent); override;
    procedure MessageClear(back: TBitmap);
    procedure AddPicture(graphic: TBitmap);
    procedure MessageRequest(str: String);
  published
    property BorderLine: TColor read LineColor write LineColor;
  end;

procedure Register;

implementation

{$UNDEF SJIS}

constructor TLetterpad.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  DisplayFont := TFont.Create;
  DisplayFont.Size := 14;
  DisplayFont.Color := clBlack;
  DisplayFont.Style := [];
  DisplayFont.Name := 'jis-fixed';
  StrCnv := TE2Uni.Create;
end;

procedure TLetterpad.MessageClear(back: TBitmap);
var  rect: TRect;
begin
  rect.Top := 0;
  rect.Left := 0;
  rect.Bottom := back.Height;
  rect.Right := back.Width;
  Picture.Bitmap.Width := back.Width;
  Picture.Bitmap.Height := back.Height;
  Picture.Bitmap.PixelFormat := pf32bit;
  Picture.Bitmap.Canvas.CopyMode := cmSrcCopy;
  Picture.Bitmap.Canvas.CopyRect(rect, back.Canvas, rect);
  Picture.Bitmap.Canvas.Font := DisplayFont;
  Width := back.Width;
  Height := back.Height;
  FontX := 8 + Picture.Bitmap.Canvas.TextWidth('');
  FontY := Height - Picture.Bitmap.Canvas.TextHeight('') - 4;
end;

procedure TLetterpad.AddPicture(graphic: TBitmap);
var y: Integer;
var rect1: TRect;
var rect2: TRect;
begin
  graphic.PixelFormat := pf32bit;
  y := Picture.Bitmap.Height;
//  Picture.Bitmap.Width := Width;
  Picture.Bitmap.Height := Picture.Bitmap.Height + graphic.Height;
  rect1.Left := 0;
  rect1.Top := y;
  rect1.Bottom := graphic.Height;
  rect1.Right := graphic.Width;
  rect2.Top := 0;
  rect2.Left := 0;
  rect2.Bottom := graphic.Height;
  rect2.Right := graphic.Width;
  Picture.Bitmap.PixelFormat := pf32bit;
  Picture.Bitmap.Canvas.CopyMode := cmSrcCopy;
  Picture.Bitmap.Canvas.CopyRect(rect1, graphic.Canvas, rect2);
  Width := Picture.Bitmap.Width;
  Height := Picture.Bitmap.Height;
  FontY := FontY + graphic.Height;
end;

{ ʸɽꥯ }
procedure Tletterpad.MessageRequest(str: String);
var display: String;
var unidisp: WideString;
var chr: Byte;
begin
  Kaigyou;
  while length(str) > 0 do begin
    chr := byte(str[1]);
{$IFDEF SJIS}
    if ((chr > $80) and (chr < $a0)) or
        ((chr > $df) and (chr < $f0)) then
{$ELSE}
    if (chr > $A0) and (chr <= $fe) then
{$ENDIF}
    begin
      display := str[1]+str[2];
      Delete(str, 1, 2);
    end
    else begin
      display := str[1];
      Delete(str, 1, 1);
    end;
    {-- ե --}
{$IFDEF SJIS}
    if chr >= $f0 then
    begin
      { -- ʸ̿ }
      if chr = $f0 then kaigyou;
      if chr = $f1 then
      begin
        kaigyou;
        display := ''; { 2byte ڡ }
        unidisp := StrCnv.CnvStrCache(display);
        Picture.Bitmap.Canvas.Font := DisplayFont;
        Picture.Bitmap.Canvas.Brush.Style := bsClear;
        Picture.Bitmap.Canvas.TextOut(FontX, FontY, unidisp);
        FontX := FontX + Picture.Bitmap.Canvas.TextWidth(unidisp);
      end;
      if chr = $f4 then DisplayFont.Style := [fsBold];
      if chr = $f5 then DisplayFont.Style := [];
      if chr = $f6 then DisplayFont.Color := clFuchsia;
      if chr = $f7 then DisplayFont.Color := clBlack;
    end
{$ELSE}
  {----- EUC λü쥳 $ff + code }
    if chr = $ff then
    begin
      chr := byte(str[1]);
      { -- ʸ̿ }
      if chr = $f0 then kaigyou;
      if chr = $f1 then
      begin
        kaigyou;
        display := ''; { 2byte ڡ }
        unidisp := StrCnv.CnvStrCache(display);
        Picture.Bitmap.Canvas.Font := DisplayFont;
        Picture.Bitmap.Canvas.Brush.Style := bsClear;
        Picture.Bitmap.Canvas.TextOut(FontX, FontY, unidisp);
        FontX := FontX + Picture.Bitmap.Canvas.TextWidth(unidisp);
      end;
      if chr = $f4 then DisplayFont.Style := [fsBold];
      if chr = $f5 then DisplayFont.Style := [];
      if chr = $f6 then DisplayFont.Color := clFuchsia;
      if chr = $f7 then DisplayFont.Color := clWhite;
      { 楳ʬڼΤ }
      Delete(str, 1, 1);
    end
{$ENDIF}
    else begin
      { -- ̾ʸɽ }
      unidisp := StrCnv.CnvStrCache(display);
      Picture.Bitmap.Canvas.Font := DisplayFont;
      Picture.Bitmap.Canvas.Brush.Style := bsClear;
      Picture.Bitmap.Canvas.TextOut(FontX, FontY, unidisp);
      FontX := FontX + Picture.Bitmap.Canvas.TextWidth(unidisp);
    end;
    { §å }
    if FontX > (Width - Picture.Bitmap.Canvas.TextWidth('')) then
    begin
     if length(str) > 0 then
     begin
       chr := byte(str[1]);
{$IFDEF SJIS}
       if ((chr > $80) and (chr < $a0)) or
          ((chr > $df) and (chr < $f0)) then
{$ELSE}
       if (chr > $A0) and (chr <= $fe) then
{$ENDIF}
       begin
         display := str[1]+str[2];
       end
       else begin
         display := str[1];
       end;
       if (Length(display) = 1) or (KinsokuCheck(display) = False) then
       begin
         kaigyou;
      end;
    end
    else Kaigyou;
    end;
  end;
end;

{ Խ }
procedure TLetterpad.Kaigyou;
var  y: Integer;
var  bmp: TBitmap;
begin
  bmp := TBitmap.Create;
  y := Picture.Bitmap.Canvas.TextHeight('') + 12;
  bmp.PixelFormat := pf32bit;
  bmp.Width := width;
  bmp.Height := y;
  with bmp.Canvas do
  begin
    Pen.Color := LineColor;
    Pen.Width := 2;
    Pen.Mode := pmCopy;
    Pen.Style := psSolid;
    MoveTo(6, y-3);
    LineTo(Width-6, y-3);
  end;
  bmp.PixelFormat := pf32bit;
  AddPicture(bmp);
  bmp.Destroy;
  FontX := 8;
end;

{ §ʸå }
function TLetterpad.KinsokuCheck(kana: String): Boolean;
begin
  KinsokuCheck := False;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
   if kana = #$a1#$a4 then KinsokuCheck := True;
   if kana = #$a3#$a4 then KinsokuCheck := True;
   if kana = #$a5#$a4 then KinsokuCheck := True;
   if kana = #$a7#$a4 then KinsokuCheck := True;
   if kana = #$a8#$a4 then KinsokuCheck := True;
   if kana = #$c3#$a4 then KinsokuCheck := True;
   if kana = #$e3#$a4 then KinsokuCheck := True;
   if kana = #$e5#$a4 then KinsokuCheck := True;
   if kana = #$e7#$a4 then KinsokuCheck := True;
   if kana = #$bc#$a1 then KinsokuCheck := True;
   if kana = #$a2#$a1 then KinsokuCheck := True;
   if kana = #$a3#$a1 then KinsokuCheck := True;
end;


procedure Register;
begin
  RegisterComponents('FumiFumi', [TLetterpad]);
end;

end.
