unit message;

interface

uses
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QExtCtrls, Types, euc2uni;

type
  TMessage = class(TImage)
  private
    BGpattern: TBitmap;
    IsDisplayMessage: Boolean;
    FontX, FontY: Integer;
    Nextpage: Boolean;
    StrCnv : TE2Uni;
    function KinsokuCheck(kana: String): Boolean;
    procedure Kaigyou;
    procedure Kaipage;
  protected
    { Protected  }
  public
    DisplayFont: TFont;
    constructor Create(AOwner: TComponent); override;
    procedure MessageClear(back: TBitmap);
    procedure NewPage;
    function MessageRequest(str: String): String;
  published
    property IsMessage: Boolean read IsDisplayMessage write IsDisplayMessage;
  end;


procedure Register;

implementation

{$UNDEF SJIS}

constructor TMessage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  IsDisplayMessage := False;
  BGpattern := TBitMap.Create;
  BGpattern.Width := Width;
  BGpattern.Height := Height;
  DisplayFont := TFont.Create;
  DisplayFont.Size := 18;
  DisplayFont.Color := clWhite;
  DisplayFont.Style := [];
  DisplayFont.Name := 'jis-fix';
  Picture.Bitmap := BGpattern;
  StrCnv := TE2Uni.Create;
end;

procedure TMessage.MessageClear(back: TBitmap);
var  rect: TRect;
begin
  Width := back.Width;
  Height := back.Height;
  rect.Top := 0;
  rect.Left := 0;
  rect.Bottom := Height;
  rect.Right := Width;
  BGpattern.Width := Width;
  BGpattern.Height := Height;
  BGpattern.Canvas.CopyMode := cmSrcCopy;
  BGpattern.Canvas.CopyRect(rect, back.Canvas, rect);
  Picture.Bitmap.Width := Width;
  Picture.Bitmap.Height := Height;
  Picture.Bitmap.Canvas.CopyMode := cmSrcCopy;
  Picture.Bitmap.Canvas.CopyRect(rect, BGpattern.Canvas, rect);
  Picture.Bitmap.Canvas.Font := DisplayFont;
  FontX := 8;
  FontY := 8;
end;

procedure TMessage.NewPage;
var  rect: TRect;
begin
  rect.Top := 0;
  rect.Left := 0;
  rect.Bottom := Height;
  rect.Right := Width;
  Picture.Bitmap.Canvas.CopyRect(rect, BGpattern.Canvas, rect);
  Picture.Bitmap.Canvas.Font := DisplayFont;
  FontX := 8;
  FontY := 8;
end;

function TMessage.MessageRequest(str: String): String;
var
    StrCnv  : TE2Uni;
var display: String;
var unidisp: WideString;
var chr: Byte;
begin
  Nextpage := False;
  StrCnv := TE2Uni.Create;
  while length(str) > 0 do begin
    chr := byte(str[1]);
{$IFDEF SJIS}
    if ((chr > $80) and (chr < $a0)) or
        ((chr > $df) and (chr < $f0)) then
{$ELSE}
    if (chr > $A0) and (chr <= $fe) then
{$ENDIF}
    begin
      display := str[1]+str[2];
      Delete(str, 1, 2);
    end
    else begin
      display := str[1];
      Delete(str, 1, 1);
    end;
    {-- ե --}
{$IFDEF SJIS}
    if chr >= $f0 then
    begin
      { -- ʸ̿ }
      if chr = $f0 then kaigyou;
      if chr = $f1 then
      begin
        kaigyou;
        display := ''; { 2byte ڡ }
        unidisp := StrCnv.CnvStrCache(display);
        Picture.Bitmap.Canvas.Font := DisplayFont;
        Picture.Bitmap.Canvas.Brush.Style := bsClear;
        Picture.Bitmap.Canvas.TextOut(FontX, FontY, unidisp);
        FontX := FontX + Picture.Bitmap.Canvas.TextWidth(unidisp);
      end;
      if chr = $f2 then Sleep(1000);
      if chr = $f3 then
      begin
        kaipage;
        str := '' + str; { 2byte ڡ }
        break;
      end;
      if chr = $f4 then DisplayFont.Style := [fsBold];
      if chr = $f5 then DisplayFont.Style := [];
      if chr = $f6 then DisplayFont.Color := clFuchsia;
      if chr = $f7 then DisplayFont.Color := clWhite;
    end
{$ELSE}
  {----- EUC λü쥳 $ff + code }
    if chr = $ff then
    begin
      chr := byte(str[1]);
      { -- ʸ̿ }
      if chr = $f0 then kaigyou;
      if chr = $f1 then
      begin
        kaigyou;
        display := ''; { 2byte ڡ }
        unidisp := StrCnv.CnvStrCache(display);
        Picture.Bitmap.Canvas.Font := DisplayFont;
        Picture.Bitmap.Canvas.Brush.Style := bsClear;
        Picture.Bitmap.Canvas.TextOut(FontX, FontY, unidisp);
        FontX := FontX + Picture.Bitmap.Canvas.TextWidth(unidisp);
      end;
      if chr = $f2 then Sleep(1000);
      if chr = $f3 then
      begin
        kaipage;
        Delete(str, 1, 1);
        str := '' + str; { 2byte ڡ }
        break;
      end;
      if chr = $f4 then DisplayFont.Style := [fsBold];
      if chr = $f5 then DisplayFont.Style := [];
      if chr = $f6 then DisplayFont.Color := clFuchsia;
      if chr = $f7 then DisplayFont.Color := clWhite;
      { 楳ʬڼΤ }
      Delete(str, 1, 1);
    end
{$ENDIF}
    else begin
      { -- ̾ʸɽ }
      unidisp := StrCnv.CnvStrCache(display);
      Picture.Bitmap.Canvas.Font := DisplayFont;
      Picture.Bitmap.Canvas.Brush.Style := bsClear;
      Picture.Bitmap.Canvas.TextOut(FontX, FontY, unidisp);
      FontX := FontX + Picture.Bitmap.Canvas.TextWidth(unidisp);
    end;
    { §å }
    if FontX > (Width - Picture.Bitmap.Canvas.TextWidth('')) then
    begin
     if length(str) > 0 then
     begin
       chr := byte(str[1]);
{$IFDEF SJIS}
       if ((chr > $80) and (chr < $a0)) or
          ((chr > $df) and (chr < $f0)) then
{$ELSE}
       if chr < $80 then
{$ENDIF}
       begin
         if chr <> $8f then
           display := str[1]+str[2]
         else
           display := str[2]+str[3];
       end
       else begin
         display := str[1];
       end;
       if (Length(display) = 1) or (KinsokuCheck(display) = False) then
       begin
         kaigyou;
      end;
    end
    else Kaigyou;
    end;
    if Nextpage = True then
    begin
      break;
    end
  end;
  MessageRequest := str;
end;

{ Խ }
procedure TMessage.Kaigyou;
begin
  FontY := FontY + Picture.Bitmap.Canvas.TextHeight('') + 8;
  FontX := 8;
  if FontY > (Height - Picture.Bitmap.Canvas.TextHeight(''))
    then Kaipage;
end;

{ ڡ }
procedure TMessage.Kaipage;
begin
  FontX := Width - Picture.Bitmap.Canvas.TextHeight('');
  FontY := Height - Picture.Bitmap.Canvas.TextHeight('');
  Picture.Bitmap.Canvas.TextOut(FontX, FontY, '');
  Nextpage := True;
end;

{ §ʸå }
function TMessage.KinsokuCheck(kana: String): Boolean;
begin
  KinsokuCheck := False;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
//  if kana = '' then KinsokuCheck := True;
   if kana = #$a1#$a4 then KinsokuCheck := True;
   if kana = #$a3#$a4 then KinsokuCheck := True;
   if kana = #$a5#$a4 then KinsokuCheck := True;
   if kana = #$a7#$a4 then KinsokuCheck := True;
   if kana = #$a8#$a4 then KinsokuCheck := True;
   if kana = #$c3#$a4 then KinsokuCheck := True;
   if kana = #$e3#$a4 then KinsokuCheck := True;
   if kana = #$e5#$a4 then KinsokuCheck := True;
   if kana = #$e7#$a4 then KinsokuCheck := True;
   if kana = #$bc#$a1 then KinsokuCheck := True;
   if kana = #$a2#$a1 then KinsokuCheck := True;
   if kana = #$a3#$a1 then KinsokuCheck := True;
end;

procedure Register;
begin
  RegisterComponents('FumiFumi', [TMessage]);
end;

end.
