unit ypf_main;

interface

uses
  SysUtils, Classes, QDialogs,
  threadmes, letterpad,
  StoryThread, ypf_select, resdialog, snddialog, sndaccept,
  meswin, QMenus, QTypes, QStdCtrls, QControls, QForms, QComCtrls,
  QGraphics, QExtCtrls, message, Types, euc2uni;

const parameter_max = 512;

type
  TPenpalMain = class(TForm)
    MainScreen: TImage;
    MailManeger: TPageControl;
    MainMessage: TMessage;
    MainMenu1: TMainMenu;
    FileMenu: TMenuItem;
    FileMenuQuit: TMenuItem;
    TabWrite: TTabSheet;
    TabReceive: TTabSheet;
    TabSend: TTabSheet;
    TabAlbum: TTabSheet;
    WriteScroll: TScrollBox;
    ReceiveSelect: TComboBox;
    AlbumSelect: TComboBox;
    AlbumScroll: TScrollBox;
    Album1: TImage;
    AlbumSwitch: TCheckBox;
    ReceiveScroll: TScrollBox;
    SendScroll: TScrollBox;
    SendSelect: TComboBox;
    Writeing: TLetterpad;
    PostLetter: TLetterpad;
    CarbonCopy: TLetterpad;
    StartWrite: TButton;
    N1: TMenuItem;
    info: TMenuItem;
    menu_config: TMenuItem;
    SendWrite: TButton;
    ReceiveDone: TButton;
   procedure FileMenuQuitClick(Sender: TObject);
    procedure MainScreenDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure MainScreenDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure AlbumSelectChange(Sender: TObject);
    procedure AlbumSwitchClick(Sender: TObject);
    procedure SendSelectChange(Sender: TObject);
    procedure ReceiveSelectChange(Sender: TObject);
    procedure MainScreenClick(Sender: TObject);
    procedure MIDIPlayerRequest(SoundName: String);
    procedure MIDIPlayerNotify(Sender: TObject);
    procedure StartWriteClick(Sender: TObject);
    procedure menu_configClick(Sender: TObject);
    procedure infoClick(Sender: TObject);
    procedure ReceiveDoneClick(Sender: TObject);
  private
    ThreadMes: TEventMessage;
    AlbumData: TStringList;
    SendHead: TStringList;
    SendFoot: TStringList;
    SendLog: TStringList;
    RecivHead: TStringList;
    RecivFoot: TStringList;
    RecivLog: TStringList;
  public
    ParameterName: TStringList;
    ParameterValue: Array [0..parameter_max] of Integer;
    StoryExec: TStory;
    ClickWait: Boolean;
    PickupPen: Boolean;
    UserSelect: Integer;
    SelectFlag: Boolean;
    EventMessage: String;
    EventMessageFlag: Boolean;
    CallYou, CallMe: String;
    ReceiveDialog: TReceiveDialog;
    SendDialog: TSendDialog;
    DoSendDialog: TDoSendAccept;
    MusicFlag: Boolean;
    MidiPlayFlag: Boolean;
    MesWinFlag: Boolean;
    MesWinVisible: Boolean;
    constructor Create(AOwner: TComponent); override;
    procedure StoryStart;
    procedure StoryDone(Sender: TObject);
    procedure DoSelect;
    procedure NextPicture(name: string);
    procedure MessageScreen(sw: Boolean);
    procedure MessageDisplay(text: String);
    procedure MessageDone(Sender: TObject);
    procedure SetParameter(name: String; value: Integer);
    function  GetParameter(name: String): Integer;
    procedure AddAlbum(name, index: String);
    procedure AddSendLog(log, index, head, foot: String);
    procedure AddReceiveLog(log, index, head, foot: String);
  published
  end;

var
  PenpalMain: TPenpalMain;

implementation

uses configwin, splash;

{$R *.xfm}


{ --- 󤹤Ȥ餯 }
constructor TPenpalMain.Create(AOwner: TComponent);
var bmp: TBitmap;
var cname : array[0..128] of char;
var i: Integer;
begin
  inherited Create(AOwner);
  { --- եåƤ }
  bmp := TBitmap.Create;
  try
    bmp.LoadFromFile(StrPCopy(cname, 'shuter01.bmp'));
  except
    ShowMessage('shuter01.bmp ץǤޤ');
    close;
  end;
  Writeing.MessageClear(bmp);
  PostLetter.MessageClear(bmp);
  CarbonCopy.MessageClear(bmp);
  Album1.Picture.Bitmap := bmp;
  bmp.Destroy;
  { ---  }
  Randomize;
  Selecter := TSelecter.Create(AOwner);
  Selecter.Visible := False;
  ParameterName := TStringList.Create;
  ParameterName.Sorted := False;
  ParameterName.Clear;
  for i := 0 to parameter_max do
    ParameterValue[i] := 0;
  MailManeger.Visible := False;
  MesWinFlag := True;
  MesWinVisible := False;
  MusicFlag := False;
  MidiPlayFlag := True;
  CallYou := 'ʤ';
  CallMe  := '錄';
  { --- Ƽ }
  AlbumData := TStringList.Create;
  AlbumData.Sorted := false;
  AlbumData.Clear;
  SendHead := TStringList.Create;
  SendHead.Sorted := false;
  SendHead.Clear;
  SendFoot := TStringList.Create;
  SendFoot.Sorted := false;
  SendFoot.Clear;
  SendLog := TStringList.Create;
  SendLog.Sorted := false;
  SendLog.Clear;
  RecivHead := TStringList.Create;
  RecivHead.Sorted := false;
  RecivHead.Clear;
  RecivFoot := TStringList.Create;
  RecivFoot.Sorted := false;
  RecivFoot.Clear;
  RecivLog := TStringList.Create;
  RecivLog.Sorted := false;
  RecivLog.Clear;
  AlbumSelect.Items.Clear;
  SendSelect.Items.Clear;
  ReceiveSelect.Items.Clear;
end;

procedure TPenpalMain.StoryStart;
begin
  { --- ȡ꡼󥿥ץư }
  StoryExec := TStory.Create(False);
  StoryExec.OnTerminate := StoryDone;
end;

procedure TPenpalMain.StoryDone(Sender: TObject);
begin
  { --- ʤȥ顼ˤʤ }
  { StoryExec.Free; }
end;


{ --- λ }
procedure TPenpalMain.FileMenuQuitClick(Sender: TObject);
begin
  close;
end;


{ --- ٥Ȳɽꥯ }
procedure TPenpalMain.NextPicture(name : string);
var cname : array[0..128] of char;
    check : TComponentState;
begin
  try
    repeat
      check := MainScreen.ComponentState;
      if check <> [] then sleep(1);
    until check = [];
    MainScreen.Picture.LoadFromFile( StrPCopy(cname, name));
//    MainScreen.Picture.Bitmap.IgnorePalette := True;
  except
    ShowMessage(name+' ץǤޤ');
  end;
end;


{ --- ɥåɥɥå׽ }
procedure TPenpalMain.DoSelect;
begin
  Selecter.Top := Top + 64;
  Selecter.Left := Left + 64;
  Selecter.Show;
end;

procedure TPenpalMain.MainScreenDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := true;
end;

procedure TPenpalMain.MainScreenDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  UserSelect := (Source as TLabel).Tag;
  SelectFlag := True;
  Selecter.Visible := False;
  {Selecter.ItemClear;}
end;


{ --- Х⡼ɽ }
procedure TPenpalMain.AlbumSelectChange(Sender: TObject);
var cname : array[0..128] of char;
var i: Integer;
begin
  if AlbumSelect.ItemIndex > -1 then
  begin
    i := AlbumSelect.ItemIndex;
    StrPCopy(cname, AlbumData.Strings[i]);
    try
      Album1.Picture.LoadFromFile(cname);
    except
      ShowMessage(AlbumData.Strings[i]+' ץǤޤ');
    end;
  end;
end;

procedure TPenpalMain.AlbumSwitchClick(Sender: TObject);
begin
  case AlbumSwitch.Checked of
    true : begin
      Album1.Width := 640;
      Album1.Height := 480;
      Album1.Stretch := False;
      end;
    false : begin
      Album1.Width := 413;
      Album1.Height := 309;
      Album1.Stretch := True;
      end;
  end;
end;

{ ---  }
procedure TPenpalMain.SendSelectChange(Sender: TObject);
var bmp, bmp2: TBitmap;
var i: Integer;
begin
  if SendSelect.ItemIndex > -1 then
  begin
    bmp  := TBitmap.Create;
    bmp2 := TBitmap.Create;
    i := SendSelect.ItemIndex;
    try
      bmp.LoadFromFile(SendHead.Strings[i]);
      bmp2.LoadFromFile(SendFoot.Strings[i]);
    except
      ShowMessage('BMP ե뤬ץǤޤ');
    end;
    CarbonCopy.MessageClear(bmp);
    CarbonCopy.MessageRequest(SendLog.Strings[i]);
    CarbonCopy.AddPicture(bmp2);
    bmp.free;
    bmp2.free;
  end;
end;

{ ---  }
procedure TPenpalMain.ReceiveSelectChange(Sender: TObject);
var bmp, bmp2: TBitmap;
var i: Integer;
begin
  if ReceiveSelect.ItemIndex > -1 then
  begin
    bmp  := TBitmap.Create;
    bmp2 := TBitmap.Create;
    i := ReceiveSelect.ItemIndex;
    try
      bmp.LoadFromFile(RecivHead.Strings[i]);
      bmp2.LoadFromFile(RecivFoot.Strings[i]);
    except
      ShowMessage('BMP ե뤬ץǤޤ');
    end;
    PostLetter.MessageClear(bmp);
    PostLetter.MessageRequest(RecivLog.Strings[i]);
    PostLetter.AddPicture(bmp2);
    bmp.free;
    bmp2.free;
  end;
end;


{--- åɥɽȥɥ ---}
procedure TPenpalMain.MessageScreen(sw: Boolean);
var bmp: TBitmap;
var rect1: TRect;
var rect2: TRect;
begin
  if sw = true then
  begin
    bmp := TBitmap.Create;
    bmp.Width := MainMessage.Width;
    bmp.Height := MainMessage.Height;
    with bmp.Canvas do
    begin
      Brush.Color := clBlue;
      Pen.Color := clGray;
      Brush.Style := bsSolid;
      Pen.Style := psSolid;
      Pen.Mode := pmCopy;
    end;
    bmp.Canvas.Rectangle(0, 0, bmp.Width, bmp.Height);
    bmp.Canvas.CopyMode := cmSrcAnd;
    rect1.Top := 0;
    rect1.Left := 0;
    rect1.Bottom := bmp.Height;
    rect1.Right := bmp.Width;
    rect2.Top := MainMessage.Top;
    rect2.Left := MainMessage.Left;
    rect2.Bottom := bmp.Height + MainMessage.Top;
    rect2.Right := bmp.Width + MainMessage.Left;
    bmp.Canvas.CopyRect(rect1, MainScreen.Canvas, rect2);
    bmp.Canvas.CopyMode := cmSrcCopy;
    MainMessage.MessageClear(bmp);
    MessageWindow.WinMessage.NewPage;
    MesWinVisible := True;
    if MesWinFlag = False then
    begin
      MainMessage.Visible := True;
      MessageWindow.Visible := False;
    end
    else begin
      MainMessage.Visible := False;
      MessageWindow.Visible := True;
    end;
    bmp.Destroy;
  end
  else begin
    MainMessage.Visible := False;
    MessageWindow.Visible := False;
    MesWinVisible := False;
  end;
end;


{--- åɥɽꥯȤȤμ ---}
procedure TPenpalMain.MessageDisplay(text: String);
begin
  EventMessage := text;
  ClickWait := False;
  ThreadMes := TEventMessage.Create(False);
  ThreadMes.OnTerminate := MessageDone;
  EventMessageFlag := True;
end;

procedure TPenpalMain.MessageDone(Sender: TObject);
begin
  { ThreadMes.Free;}
  EventMessageFlag := False;
end;

procedure TPenpalMain.MainScreenClick(Sender: TObject);
begin
  ClickWait := True;
end;


{--- ե饰 & ѥ᡼ޥ͡ ---}
procedure TPenpalMain.SetParameter(name: String; value: Integer);
var index: Integer;
begin
  if ParameterName.IndexOf(name) = -1 then
  begin
    { ¸ߤʤѥ᡼ʤ鿷å }
    index := ParameterName.Add(name);
    ParameterValue[index] := value;
  end
  else begin
    { Ǥˤѥ᡼ʤñ㥻å }
    index := ParameterName.IndexOf(name);
    ParameterValue[index] := value;
  end;
end;

function  TPenpalMain.GetParameter(name: String): Integer;
var index: Integer;
begin
  index := ParameterName.IndexOf(name);
  if index = -1 then GetParameter := 0
  else GetParameter := ParameterValue[index];
end;


{ --- MIDI ǡռ }
procedure TPenpalMain.MIDIPlayerRequest(SoundName: String);
begin
  if MusicFlag = True then
  begin
//    MIDIPlayer.Notify := False;
//    MIDIPlayer.Stop;
  end;
//  MIDIPlayer.FileName := SoundName;
//  MIDIPlayer.Open;
//  MIDIPlayer.Wait := False;
//  MIDIPlayer.Notify  := True;
//  if MidiPlayFlag = True then MIDIPlayer.Play;
  MusicFlag := True;
end;

procedure TPenpalMain.MIDIPlayerNotify(Sender: TObject);
begin
//  if MIDIPlayer.NotifyValue = nvSuccessful then
//  begin
//    MIDIPlayer.Notify  := True;
//    MIDIPlayer.Play;
//  end
//  else
//    MIDIPlayer.Notify  := False;
end;


{--- ؤˤƤֿ⡼ɥȥܥ ---}
procedure TPenpalMain.StartWriteClick(Sender: TObject);
begin
  PickupPen := False;
  StartWrite.Visible := False;
  SendWrite.Visible := False;
end;

{--- ؤˤƤμλܥ ---}
procedure TPenpalMain.ReceiveDoneClick(Sender: TObject);
begin
  PickupPen := False;
  ReceiveDone.Visible := False;
end;


{ --- Album ǡϿ }
procedure TPenpalMain.AddAlbum(name, index: String);
begin
  if AlbumSelect.Items.IndexOf(index) = -1 then
  begin
    AlbumSelect.Items.Add(index);
    AlbumData.Add(name);
  end;
end;

{ --- ȡѤ߼Ͽ }
procedure TPenpalMain.AddSendLog(log, index, head, foot: String);
var
  UniCnv : TE2Uni;
begin
  if SendSelect.Items.IndexOf(index) = -1 then
  begin
    UniCnv := TE2Uni.Create;
    SendSelect.Items.Add(UniCnv.CnvStr(index));
    SendHead.Add(head);
    SendFoot.Add(foot);
    SendLog.Add(log);
    UniCnv.Free;
  end;
end;

{ --- äϿ }
procedure TPenpalMain.AddReceiveLog(log, index, head, foot: String);
var
  UniCnv : TE2Uni;
begin
  if ReceiveSelect.Items.IndexOf(index) = -1 then
  begin
    UniCnv := TE2Uni.Create;
    ReceiveSelect.Items.Add(index);
    RecivHead.Add(head);
    RecivFoot.Add(foot);
    RecivLog.Add(log);
    UniCnv.Free;
  end;
end;

{ ꥦɥɽ }
procedure TPenpalMain.menu_configClick(Sender: TObject);
begin
  FumiConfig.Top := Top + 32;
  FumiConfig.Left := Left + 32;
  FumiConfig.Show;
end;

procedure TPenpalMain.infoClick(Sender: TObject);
begin
  Information.ShowModal;
end;


end.
